routes/web.php
<?php

Route::redirect('/', '/login');
Route::get('/home', function () {
    if (session('status')) {
        return redirect()->route('admin.home')->with('status', session('status'));
    }

    return redirect()->route('admin.home');
});

Auth::routes(['register' => false]);
// Admin

Route::group(['prefix' => 'admin', 'as' => 'admin.', 'namespace' => 'Admin', 'middleware' => ['auth']], function () {
    Route::get('/', 'HomeController@index')->name('home');
    // Users
    Route::delete('users/destroy', 'UsersController@massDestroy')->name('users.massDestroy');
    Route::resource('users', 'UsersController');

    // Wards
    Route::get('search-wards', 'WardsController@search')->name('wards.search');
    Route::resource('wards', 'WardsController', ['except' => ['create', 'store', 'edit', 'update', 'destroy']]);

    // Villages
    Route::get('search-villages', 'VillagesController@search')->name('villages.search');
    Route::delete('villages/destroy', 'VillagesController@massDestroy')->name('villages.massDestroy');
    Route::resource('villages', 'VillagesController');

    // Thematic Areas
    Route::delete('thematic-areas/destroy', 'ThematicAreasController@massDestroy')->name('thematic-areas.massDestroy');
    Route::resource('thematic-areas', 'ThematicAreasController');

    // Age Bands
    Route::delete('age-bands/destroy', 'AgeBandsController@massDestroy')->name('age-bands.massDestroy');
    Route::resource('age-bands', 'AgeBandsController');

    // Value Chains
    Route::delete('value-chains/destroy', 'ValueChainsController@massDestroy')->name('value-chains.massDestroy');
    Route::resource('value-chains', 'ValueChainsController');

    // Training Categories
    Route::delete('training-categories/destroy', 'TrainingCategoriesController@massDestroy')->name('training-categories.massDestroy');
    Route::resource('training-categories', 'TrainingCategoriesController');

    // Topics
    Route::delete('topics/destroy', 'TopicsController@massDestroy')->name('topics.massDestroy');
    Route::resource('topics', 'TopicsController');

    // Facilitators
    Route::get('search-facilitators', 'FacilitatorsController@search')->name('facilitators.search');
    Route::delete('facilitators/destroy', 'FacilitatorsController@massDestroy')->name('facilitators.massDestroy');
    Route::post('facilitators/import', 'FacilitatorsController@import')->name('facilitators.import');
    Route::resource('facilitators', 'FacilitatorsController');

    // Groups
    Route::get('search-groups', 'GroupsController@search')->name('groups.search');
    Route::delete('groups/destroy', 'GroupsController@massDestroy')->name('groups.massDestroy');
    // Route::get('groups/{group_id}/members/create', 'GroupsController@createForGroup')->name('group.members.create');
    //Route::post('mass-store-members', 'GroupsController@massStore')->name('members.massStore');
    Route::resource('groups', 'GroupsController');


    // Beneficiaries
    Route::get('search-beneficiaries', 'BeneficiariesController@search')->name('beneficiaries.search');
    Route::delete('beneficiaries/destroy', 'BeneficiariesController@massDestroy')->name('beneficiaries.massDestroy');
    Route::get('beneficiaries/export','BeneficiariesController@export')->name('beneficiaries.export');
    Route::resource('beneficiaries', 'BeneficiariesController');

    // Trainings
    Route::post('trainings/import', 'TrainingsController@import')->name('trainings.import');
    Route::delete('trainings/destroy', 'TrainingsController@massDestroy')->name('trainings.massDestroy');
    // Route::post('trainings/process-excel-import', 'TrainingsController@processExcelImport')->name('trainigs.processCsvImport');
    Route::resource('trainings', 'TrainingsController');

    // Attendances
    Route::delete('attendances/destroy', 'AttendancesController@massDestroy')->name('attendances.massDestroy');
    Route::get('trainings/{training_id}/attendances/create', 'AttendancesController@createForTraining')->name('training.attendances.create');
    Route::post('mass-store-attendances', 'AttendancesController@massStore')->name('attendances.massStore');
    Route::resource('attendances', 'AttendancesController');

      //Members
    Route::delete('members/destroy', 'MembersController@massDestroy')->name('members.massDestroy');
    Route::get('groups/{group_id}/members/create', 'MembersController@createForGroup')->name('group.members.create');
    Route::get('value-chain-training-sites/{group_id}/members/create', 'MembersController@createForValueChainTrainingSite')->name('vcts.members.create');
    Route::get('care-groups/{group_id}/members/create', 'MembersController@createForCareGroup')->name('care-groups.members.create');
    Route::get('isals/{group_id}/members/create', 'MembersController@createForIsals')->name('isals.members.create');
    Route::post('mass-store-members', 'MembersController@massStore')->name('members.massStore');
    Route::post('mass-store-vcts-members', 'MembersController@massStoreValueChainTrainingSite')->name('members.massStoreValueChainTrainingSite');
    Route::post('mass-store-caregroups-members', 'MembersController@massStoreCareGroup')->name('members.massStoreCareGroup');
    Route::post('mass-store-isals-members', 'MembersController@massStoreIsal')->name('members.massStoreIsal');
    Route::resource('members', 'MembersController');

    //Value Chain Training Site - Group-Category
    Route::post('value-chain-training-sites/import', 'ValueChainTrainingSiteController@import')->name('value-chain-training-sites.import');
    Route::delete('value-chain-training-sites/destroy', 'ValueChainTrainingSiteController@massDestroy')->name('value-chain-training-sites.massDestroy');
    Route::get('value-chain-training-sites/create', 'ValueChainTrainingSiteController@create')->name('value-chain-training-sites.create');
    Route::get('value-chain-training-sites/{group}', 'ValueChainTrainingSiteController@showGroup')->name('value-chain-training-sites.showGroup');
    Route::get('value-chain-training-sites/{group}/edit', 'ValueChainTrainingSiteController@edit')->name('value-chain-training-sites.edit');
    Route::patch('value-chain-training-sites/{id}', 'ValueChainTrainingSiteController@update')->name('value-chain-training-sites.update');
    Route::delete('value-chain-training-sites/{group}', 'ValueChainTrainingSiteController@destroy')->name('value-chain-training-sites.destroy');
    Route::resource('value-chain-training-sites', 'ValueChainTrainingSiteController');

    //Care Group - Group-Category
    Route::post('care-groups/import', 'CareGroupController@import')->name('care-groups.import');
    Route::delete('care-groups/destroy', 'CareGroupController@massDestroy')->name('care-groups.massDestroy');
    Route::get('care-groups/create', 'CareGroupController@create')->name('care-groups.create');
    Route::get('care-groups/{group}', 'CareGroupController@show')->name('care-groups.show');
    Route::get('care-groups/{group}/edit', 'CareGroupController@edit')->name('care-groups.edit');
    Route::patch('care-groups/{id}', 'CareGroupController@update')->name('care-groups.update');
    Route::delete('care-groups/{group}', 'CareGroupController@destroy')->name('care-groups.destroy');
    Route::resource('care-groups', 'CareGroupController');
    
    //Isals Group - Group Category
    Route::post('isals/import', 'IsalsController@import')->name('isals.import');
    Route::delete('isals/destroy', 'IsalsController@massDestroy')->name('isals.massDestroy');
    Route::get('isals/create', 'IsalsController@create')->name('isals.create');
    Route::get('isals/{group}', 'IsalsController@show')->name('isals.show');
    Route::get('isals/{group}/edit', 'IsalsController@edit')->name('isals.edit');
    Route::patch('isals/{id}', 'IsalsController@update')->name('isals.update');
    Route::delete('isals/{group}', 'IsalsController@destroy')->name('isals.destroy');
    Route::resource('isals', 'IsalsController');
    
    //Interventions
    Route::post('interventions/import', 'InterventionsController@import')->name('interventions.import');
    Route::delete('interventions/destroy', 'InterventionsController@massDestroy')->name('interventions.massDestroy');
    Route::get('interventions/map', 'InterventionsController@map')->name('interventions.map');
    Route::resource('interventions', 'InterventionsController');
    
    //Distribution
    Route::post('distributions/import', 'DistributionsController@import')->name('distributions.import');
    Route::get('distributions/export','DistributionsController@export')->name('distributions.export');
    Route::delete('distributions/destroy', 'DistributionsController@massDestroy')->name('distributions.massDestroy');
    Route::get('distributions/{distribution}/edit', 'DistributionsController@edit')->name('distributions.edit');
    Route::patch('distributions/{id}', 'DistributionsController@update')->name('distributions.update');
    Route::resource('distributions', 'DistributionsController');
    
    //Crops Data
    Route::post('crops/import', 'CropsController@import')->name('crops.import');
    Route::get('crops/export','CropsController@export')->name('crops.export');
    Route::delete('crops/destroy', 'CropsController@massDestroy')->name('crops.massDestroy');
    Route::resource('crops', 'CropsController');
    
    //Pfumvudza
    Route::post('pfumvudza/import', 'PfumvudzaController@import')->name('pfumvudza.import');
    Route::get('pfumvudza/export','PfumvudzaController@export')->name('pfumvudza.export');
    Route::delete('pfumvudza/destroy', 'PfumvudzaController@massDestroy')->name('pfumvudza.massDestroy');
    Route::resource('pfumvudza', 'PfumvudzaController');
    
    //Clean Facilitator - Teachers
    Route::delete('teachers/destroy', 'TeachersController@massDestroy')->name('teachers.massDestroy');
    Route::post('teachers/import', 'TeachersController@import')->name('teachers.import');

app/Models/ValueChain.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use \DateTimeInterface;

class ValueChain extends Model
{
    use SoftDeletes;

    public $table = 'value_chains';

    protected $dates = [
        'created_at',
        'updated_at',
        'deleted_at',
    ];

    protected $fillable = [
        'name',
       // 'categories',
        'created_at',
        'updated_at',
        'deleted_at',
    ];

    const CATEGORIES_SELECT = [
        'Food Security'              => 'Food Security',
        'Commercial'                 => 'Commercial',
        'Food Security & Commercial' => 'Food Security & Commercial',
    ];

    protected function serializeDate(DateTimeInterface $date)
    {
        return $date->format('Y-m-d H:i:s');
    }

    public function trainings()
    {
        return $this->belongsToMany(Training::class);
    }
    
    public function groups()
    {
        return $this->hasMany(Group::class);
    }
}

app/Http/Controllers/Admin/ValueChainsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\MassDestroyValueChainRequest;
use App\Http\Requests\StoreValueChainRequest;
use App\Http\Requests\UpdateValueChainRequest;
use App\Models\ValueChain;
use Gate;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use Yajra\DataTables\Facades\DataTables;

class ValueChainsController extends Controller
{
    public function index(Request $request)
    {
        abort_if(Gate::denies('value_chain_access'), Response::HTTP_FORBIDDEN, '403 Forbidden');

        if ($request->ajax()) {
            $query = ValueChain::query()->select(sprintf('%s.*', (new ValueChain)->table));
            $table = Datatables::of($query);

            $table->addColumn('placeholder', '&nbsp;');
            $table->addColumn('actions', '&nbsp;');

            $table->editColumn('actions', function ($row) {
                $viewGate      = 'value_chain_show';
                $editGate      = 'value_chain_edit';
                $deleteGate    = 'value_chain_delete';
                $crudRoutePart = 'value-chains';

                return view('partials.datatablesActions', compact(
                    'viewGate',
                    'editGate',
                    'deleteGate',
                    'crudRoutePart',
                    'row'
                ));
            });

            $table->editColumn('id', function ($row) {
                return $row->id ? $row->id : "";
            });
            $table->editColumn('name', function ($row) {
                return $row->name ? $row->name : "";
            });
            $table->editColumn('categories', function ($row) {
                return $row->categories ? ValueChain::CATEGORIES_SELECT[$row->categories] : '';
            });

            $table->rawColumns(['actions', 'placeholder']);

            return $table->make(true);
        }

        return view('admin.valueChains.index');
    }

    public function create()
    {
        abort_if(Gate::denies('value_chain_create'), Response::HTTP_FORBIDDEN, '403 Forbidden');

        return view('admin.valueChains.create');
    }

    public function store(StoreValueChainRequest $request)
    {
        $valueChain = ValueChain::create($request->all());

        return redirect()->route('admin.value-chains.index');
    }

    public function edit(ValueChain $valueChain)
    {
        abort_if(Gate::denies('value_chain_edit'), Response::HTTP_FORBIDDEN, '403 Forbidden');

        return view('admin.valueChains.edit', compact('valueChain'));
    }

    public function update(UpdateValueChainRequest $request, ValueChain $valueChain)
    {
        $valueChain->update($request->all());

        return redirect()->route('admin.value-chains.index');
    }

    public function show(ValueChain $valueChain)
    {
        abort_if(Gate::denies('value_chain_show'), Response::HTTP_FORBIDDEN, '403 Forbidden');

        return view('admin.valueChains.show', compact('valueChain'));
    }

    public function destroy(ValueChain $valueChain)
    {
        abort_if(Gate::denies('value_chain_delete'), Response::HTTP_FORBIDDEN, '403 Forbidden');

        $valueChain->delete();

        return back();
    }

    public function massDestroy(MassDestroyValueChainRequest $request)
    {
        ValueChain::whereIn('id', request('ids'))->delete();

        return response(null, Response::HTTP_NO_CONTENT);
    }
}

resources/views/admin/valueChains/create.blade.php
@extends('layouts.admin')
@section('content')

<div class="card">
    <div class="card-header">
        {{ trans('global.create') }} {{ trans('cruds.valueChain.title_singular') }}
    </div>

    <div class="card-body">
        <form method="POST" action="{{ route("admin.value-chains.store") }}" enctype="multipart/form-data">
            @csrf
            <div class="form-group">
                <label class="required" for="name">{{ trans('cruds.valueChain.fields.name') }}</label>
                <input class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" type="text" name="name" id="name" value="{{ old('name', '') }}" required>
                @if($errors->has('name'))
                    <div class="invalid-feedback">
                        {{ $errors->first('name') }}
                    </div>
                @endif
                <span class="help-block">{{ trans('cruds.valueChain.fields.name_helper') }}</span>
            </div>
            <div class="form-group">
                <label class="required">{{ trans('cruds.valueChain.fields.categories') }}</label>
                <select class="form-control {{ $errors->has('categories') ? 'is-invalid' : '' }}" name="categories" id="categories" required>
                    <option value disabled {{ old('categories', null) === null ? 'selected' : '' }}>{{ trans('global.pleaseSelect') }}</option>
                    @foreach(App\Models\ValueChain::CATEGORIES_SELECT as $key => $label)
                        <option value="{{ $key }}" {{ old('categories', 'Food Security & Commercial') === (string) $key ? 'selected' : '' }}>{{ $label }}</option>
                    @endforeach
                </select>
                @if($errors->has('categories'))
                    <div class="invalid-feedback">
                        {{ $errors->first('categories') }}
                    </div>
                @endif
                <span class="help-block">{{ trans('cruds.valueChain.fields.categories_helper') }}</span>
            </div>
            <div class="form-group">
                <button class="btn btn-danger" type="submit">
                    {{ trans('global.save') }}
                </button>
            </div>
        </form>
    </div>
</div>



@endsection

resources/views/admin/valueChains/edit.blade.php
@extends('layouts.admin')
@section('content')

<div class="card">
    <div class="card-header">
        {{ trans('global.edit') }} {{ trans('cruds.valueChain.title_singular') }}
    </div>

    <div class="card-body">
        <form method="POST" action="{{ route("admin.value-chains.update", [$valueChain->id]) }}" enctype="multipart/form-data">
            @method('PUT')
            @csrf
            <div class="form-group">
                <label class="required" for="name">{{ trans('cruds.valueChain.fields.name') }}</label>
                <input class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" type="text" name="name" id="name" value="{{ old('name', $valueChain->name) }}" required>
                @if($errors->has('name'))
                    <div class="invalid-feedback">
                        {{ $errors->first('name') }}
                    </div>
                @endif
                <span class="help-block">{{ trans('cruds.valueChain.fields.name_helper') }}</span>
            </div>
            <div class="form-group">
                <label class="required">{{ trans('cruds.valueChain.fields.categories') }}</label>
                <select class="form-control {{ $errors->has('categories') ? 'is-invalid' : '' }}" name="categories" id="categories" required>
                    <option value disabled {{ old('categories', null) === null ? 'selected' : '' }}>{{ trans('global.pleaseSelect') }}</option>
                    @foreach(App\Models\ValueChain::CATEGORIES_SELECT as $key => $label)
                        <option value="{{ $key }}" {{ old('categories', $valueChain->categories) === (string) $key ? 'selected' : '' }}>{{ $label }}</option>
                    @endforeach
                </select>
                @if($errors->has('categories'))
                    <div class="invalid-feedback">
                        {{ $errors->first('categories') }}
                    </div>
                @endif
                <span class="help-block">{{ trans('cruds.valueChain.fields.categories_helper') }}</span>
            </div>
            <div class="form-group">
                <button class="btn btn-danger" type="submit">
                    {{ trans('global.save') }}
                </button>
            </div>
        </form>
    </div>
</div>



@endsection

resources/views/admin/valueChains/index.blade.php
@extends('layouts.admin')
@section('content')
@can('value_chain_create')
    <div style="margin-bottom: 10px;" class="row">
        <div class="col-lg-12">
            <a class="btn btn-success" href="{{ route('admin.value-chains.create') }}">
                {{ trans('global.add') }} {{ trans('cruds.valueChain.title_singular') }}
            </a>
        </div>
    </div>
@endcan
<div class="card">
    <div class="card-header">
        {{ trans('cruds.valueChain.title_singular') }} {{ trans('global.list') }}
    </div>

    <div class="card-body">
        <table class=" table table-bordered table-striped table-hover ajaxTable datatable datatable-ValueChain">
            <thead>
                <tr>
                    <th width="10">

                    </th>
                    <th>
                        {{ trans('cruds.valueChain.fields.id') }}
                    </th>
                    <th>
                        {{ trans('cruds.valueChain.fields.name') }}
                    </th>
                    <th>
                        {{ trans('cruds.valueChain.fields.categories') }}
                    </th>
                    <th>
                        &nbsp;
                    </th>
                </tr>
            </thead>
        </table>
    </div>
</div>



@endsection
@section('scripts')
@parent
<script>
    $(function () {
  let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
@can('value_chain_delete')
  let deleteButtonTrans = '{{ trans('global.datatables.delete') }}';
  let deleteButton = {
    text: deleteButtonTrans,
    url: "{{ route('admin.value-chains.massDestroy') }}",
    className: 'btn-danger',
    action: function (e, dt, node, config) {
      var ids = $.map(dt.rows({ selected: true }).data(), function (entry) {
          return entry.id
      });

      if (ids.length === 0) {
        alert('{{ trans('global.datatables.zero_selected') }}')

        return
      }

      if (confirm('{{ trans('global.areYouSure') }}')) {
        $.ajax({
          headers: {'x-csrf-token': _token},
          method: 'POST',
          url: config.url,
          data: { ids: ids, _method: 'DELETE' }})
          .done(function () { location.reload() })
      }
    }
  }
  dtButtons.push(deleteButton)
@endcan

  let dtOverrideGlobals = {
    buttons: dtButtons,
    processing: true,
    serverSide: true,
    retrieve: true,
    aaSorting: [],
    ajax: "{{ route('admin.value-chains.index') }}",
    columns: [
      { data: 'placeholder', name: 'placeholder' },
{ data: 'id', name: 'id' },
{ data: 'name', name: 'name' },
{ data: 'categories', name: 'categories' },
{ data: 'actions', name: '{{ trans('global.actions') }}' }
    ],
    orderCellsTop: true,
    order: [[ 1, 'asc' ]],
    pageLength: 100,
  };
  let table = $('.datatable-ValueChain').DataTable(dtOverrideGlobals);
  $('a[data-toggle="tab"]').on('shown.bs.tab click', function(e){
      $($.fn.dataTable.tables(true)).DataTable()
          .columns.adjust();
  });
  
});

</script>
@endsection

resources/views/admin/valueChains/show.blade.php
@extends('layouts.admin')
@section('content')

<div class="card">
    <div class="card-header">
        {{ trans('global.show') }} {{ trans('cruds.valueChain.title') }}
    </div>

    <div class="card-body">
        <div class="form-group">
            <div class="form-group">
                <a class="btn btn-default" href="{{ route('admin.value-chains.index') }}">
                    {{ trans('global.back_to_list') }}
                </a>
            </div>
            <table class="table table-bordered table-striped">
                <tbody>
                    <tr>
                        <th>
                            {{ trans('cruds.valueChain.fields.id') }}
                        </th>
                        <td>
                            {{ $valueChain->id }}
                        </td>
                    </tr>
                    <tr>
                        <th>
                            {{ trans('cruds.valueChain.fields.name') }}
                        </th>
                        <td>
                            {{ $valueChain->name }}
                        </td>
                    </tr>
                    <tr>
                        <th>
                            {{ trans('cruds.valueChain.fields.categories') }}
                        </th>
                        <td>
                            {{ App\Models\ValueChain::CATEGORIES_SELECT[$valueChain->categories] ?? '' }}
                        </td>
                    </tr>
                </tbody>
            </table>
            <div class="form-group">
                <a class="btn btn-default" href="{{ route('admin.value-chains.index') }}">
                    {{ trans('global.back_to_list') }}
                </a>
            </div>
        </div>
    </div>
</div>

@endsection